#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// Author: Arkadiusz Pawlik

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <climits>

using namespace std;

struct B {
  int a, b, h;
  B() {}
  B(int a_, int b_, int h_) : a(a_), b(b_), h(h_) {}
};
int coords;

vector<B> data;

void test() {
  data.clear();
  int n;
  cin >> n;
  map<int, int> coord_map;
  while(n--) {
    int a, b, h;
    cin >> a >> b >> h;
    data.push_back(B(a, b, h));
    coord_map[a] = -1;
    coord_map[b] = -1;
  }
  coords = 1;
  for (map<int, int>::iterator it = coord_map.begin();
                              it != coord_map.end(); ++it) {
    it->second = coords++;
  }
  for (int i = 0; i < data.size(); ++i) {
    data[i].a = coord_map[data[i].a];
    data[i].b = coord_map[data[i].b];
  }
  vector<vector<int> > cost(coords+1, vector<int>(coords+1));
  for (int l = 1; l <= coords; ++l) {
    for (int x0 = 0; x0 + l <= coords; ++x0) {
      int h = 0, b = -1;
      for (int i = 0; i < data.size(); ++i) {
        if (x0 < data[i].a && data[i].b < x0 + l && data[i].h > h) {
          h = data[i].h;
          b = i;
        }
      }
      int cost0 = 0;
      if (b != -1) {
        cost0 = INT_MAX;
        for (int x1 = data[b].a; x1 <= data[b].b; ++x1) {
          cost0 = min(cost0, h + cost[x0][x1-x0] + cost[x1][x0+l-x1]);
        }
      }
      cost[x0][l] = cost0;
    }
  }
  cout << cost[0][coords] << endl;
}
int main() {
  int Z;
  cin >> Z;
  while(Z--) test();
}

