#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
// Author: Adam Polak
#include <iostream>
#include <string>
#include <vector>
using namespace std;

int main() {
  ios_base::sync_with_stdio(false);
  int Z;
  cin >> Z;
  while (Z--) {
    int n;
    cin >> n;
    vector<int> num(n);
    vector<bool> col(n);
    for (int i = 0; i < n; ++i) {
      string temp;
      cin >> num[i] >> temp;
      col[i] = temp[0] == 'W';
    }
    long long black = 0, white = 0;
    for (int i = 0; i < n; ++i)
      if (col[i]) white += num[i]; else black += num[i];
    if (black == 0 || white == 0) {
      cout << black + white << endl;
      continue;
    }
    int result = 0;
    int cur_black = 0, cur_white = 0;
    for (int i = 0; i < n; ++i) {
      if (col[i]) {
        for (int j = 0; j < num[i]; ++j) {
          ++cur_white;
          if (cur_white * black == cur_black * white) ++result;
        }
      } else {
        for (int j = 0; j < num[i]; ++j) {
          ++cur_black;
          if (cur_white * black == cur_black * white) ++result;
        }
      }
    }
    cout << result << endl;
  }
}
