#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <iostream>
#include <limits>
#include <random>
#include <utility>
#include <vector>
using namespace std;

int main()
{
    int s, z, n, dxmin, dxmax, dymax;
    cin >> s >> z >> n >> dxmin >> dxmax >> dymax;
    default_random_engine rnd(s);
    uniform_int_distribution<int> dx(dxmin, dxmax);
    uniform_int_distribution<int> dy(-dymax, +dymax);
    cout << z << endl;
    while (z--)
    {
        cout << n << endl;
        vector<pair<int,int>> P(n);
        int x = 0, y = 0, lx = numeric_limits<int>::max(), ly = numeric_limits<int>::max();
        for (auto & p : P)
        {
            lx = min(lx, p.first = x += dx(rnd));
            ly = min(ly, p.second = y += dy(rnd));
        }
        for (auto p : P)
            cout << p.first-lx << ' ' << p.second-ly << endl;
    }
    return 0;
}
