#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 1005;

int x[maxn], y[maxn], r[maxn];

vector < int > g[maxn];


ll sqr(ll x)
{
	return x * x;
}

ll gcd(ll a, ll b)
{
	return a ? gcd(b % a, a) : b;
}

int dir[maxn];
pair < ll, ll > ans[maxn];
int used[maxn];
int currUsed = 1;


void dfs(int v)
{
	used[v] = currUsed;
	for (int to : g[v])
	{
		if (used[to] == currUsed)
			continue;

		dir[to] = 1 - dir[v];
		ans[to] = ans[v];
		ans[to].snd *= r[to];
		ans[to].fst *= r[v];
		ll f = gcd(ans[to].fst, ans[to].snd);
		ans[to].fst /= f;
		ans[to].snd /= f;
		dfs(to);
	}
}

int main()
{
	//freopen("a.in", "r", stdin);
	int t;
	scanf("%d", &t);
	while (t--)
	{
		int n;
		scanf("%d", &n);

		for (int i = 0; i < n; i++)
		{
			scanf("%d %d %d", x + i, y + i, r + i);
		}

		for (int i = 0; i < n; i++)
			g[i].clear();

		for (int i = 0; i < n; i++)
		{
			dir[i] = -1;
			for (int j = i + 1; j < n; j++)
			{
				if (sqr(x[i] - x[j]) + sqr(y[i] - y[j]) == sqr(r[i] + r[j]))
				{
					g[i].pb(j);
					g[j].pb(i);
				}
			}
		}

		currUsed++;

		ans[0] = mp(1, 1);
		dir[0] = 0;

		dfs(0);

		for (int i = 0; i < n; i++)
		{
			if (dir[i] == -1)
			{
				puts("not moving");
			}
			else
			{
				if (ans[i].snd == 1)
					printf("%lld ", ans[i].fst);
				else
				{
					printf("%lld/", ans[i].fst);
					printf("%lld ", ans[i].snd);
				}

				if (dir[i] == 0)
					puts("clockwise");
				else
					puts("counterclockwise");
			}
		}
	}
	

	return 0;
}