#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;
long long n;

long long check(long long a, long long k) {
    long long result = a * k + (k * (k - 1)) / 2;
    return result;
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n;
        //n = pow(2, i);
        bool f = false;
        for (int j = 2; j <= (1 + int(sqrt(1 + 4 * n))) / 2 + 5; j++) {
            long long l = 1;
            long long r = n / j + 5;
            while (l < r) {
                long long mid = (l + r) / 2;
                if (check(mid, j) >= n) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
            }
            if (check(r, j) == n) {
                cout << n << " = ";
                for (int z = r; z < r + j; z++) {
                    cout << z;
                    if (z != r + j - 1) {
                        cout << " + ";
                    }
                }
                cout << endl;
                f = true;
                break;
            }
        }
        if (f == false) {
            cout << "IMPOSSIBLE" << endl;
        }
    }


    return 0;
}
