#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;

long long gcd(long long x, long long y)
{
    while (x != 0 && y != 0)
        if (x > y)
            x %= y;
        else y %= x;
    return x + y;
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        vector<pair<int, char> > a;
        long long numb = 0;
        long long numa = 0;
        for (int j = 0; j < n; j++) {
            int x;
            char c;
            cin >> x >> c;
            a.push_back(make_pair(x, c));
            if (c == 'B') {
                numb += x;;
            } else {
                numa += x;
            }
        }
        if (numa == 0 || numb == 0) {
            cout << max(numa, numb) << endl;
            continue;
        }
        long long del = gcd(numa, numb);
        numa /= del;
        numb /= del;
        long long cura = 0;
        long long curb = 0;
        long long ans = 0;
        for (int j = 0; j < a.size(); j++) {
            if (a[j].second == 'B') {
                curb += a[j].first;
                if (numb * cura % numa == 0 && cura != 0 && curb != 0) {
                    long long needb = numb * cura / numa;
                    long long gdel = gcd(needb, cura);
                    if (curb >= needb && numa == cura / gdel && numb == needb / gdel && curb - a[j].first <= needb) {
                        ans++;
                        curb -= needb;
                        cura = 0;
                    }
                }
            } else {
                cura += a[j].first;
                if (numa * curb % numb == 0 && cura != 0 && curb != 0) {
                    long long needa = numa * curb / numb;
                    long long gdel = gcd(needa, curb);
                    if (cura >= needa && numb == curb / gdel && numa == needa / gdel && cura - a[j].first <= needa) {
                        ans++;
                        cura -= needa;
                        curb = 0;
                    }
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
