#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

void solve() {
	int n; scanf("%d", &n);
	n *= 2;
	vector<int> divs;
	for(ll i = 1; i * i <= n; ++i) {
		if (n%i==0) {
			divs.pb(i);
			if (i*i < n) divs.pb(n/i);
		}
	}

	const int cinf = 1000000010;
	int bestlen = cinf;
	int bestx = -1;
	forn(ii, sz(divs)) {
		int cur = divs[ii];
		int t = n/cur;
		int x = t-cur+1;
		if (x&1) continue;
		x /= 2;
		if (x <= 0) continue;
		if (cur < 2) continue;
		bestlen = cur;
		bestx = x;
		break;
	}
	if (bestx == -1) printf("IMPOSSIBLE\n");
	else {
		printf("%d =", n/2);
		int fr = bestx;
		int to = bestx+bestlen-1;
		for (int i = fr; i <= to; ++i) {
			if (i != fr) printf(" +");
			printf(" %d", i);
		}
		printf("\n");
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
