#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

ll gcd(ll a, ll b){
	while(b){
		a %= b;
		swap(a, b);
	}
	return a;
}

struct frac{
	ll p, q;
	bool fl;
	frac() : p(0), q(0) { }
	frac(ll p, ll q) : p(p), q(q) { }
	frac simp(){
		ll g = gcd(p, q);
		return frac(p / g, q / g);
	}
	void print(){
		frac cur = simp();
		cout << cur.p;
		if (cur.q != 1) cout << "/"  <<  cur.q;
		cout << " ";
		if (fl) cout << " clockwise\n";
		else cout << " counterclockwise\n";
	}
};

vector<vector<int> > vv;

struct wheel{
	ll x,y,r;
};
vector<wheel> mas;
ll sqr(ll a){
	return a*a;
}
ll dist(int i,int j){
	return sqr(mas[i].x-mas[j].x) + sqr(mas[i].y-mas[j].y);
}
bool used[1010];
bool check(int i,int j){
	ll d = sqr(mas[i].r + mas[j].r);
	if(d==dist(i,j))
		return true;
	return false;
}
vector<frac> ans;
void dfs(int v,int dir){
	ans[v] = frac( mas[0].r,mas[v].r);
	ans[v].fl = dir;
	used[v] = true;
	for(int i = 0;i < L(vv[v]);i++){
		int to = vv[v][i];
		if(!used[to]){

			dfs(to,dir^1);
		}
	}
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int t;
	cin >> t;
	while(t--){
		int n;
		cin >> n;
		mas.clear();
		ans.clear();
		ans.resize(n);
		for(int i = 0;i < n;i++)
			used[i] = false;
		for(int i = 0;i < n;i++){
			int x,y,r;
			cin >> x >> y >> r;
			wheel t = {x,y,r};
			mas.pb(t);
		}
		vv.clear();
		vv.resize(n);
		for(int i = 0;i < n;i++){
			for(int j = 0;j < n;j++){
				if(check(i,j)){
					vv[i].pb(j);
				}
			}
		}
		dfs(0,1);
		for(int i =0;i < n;i++){
			if(!used[i]){
				cout << "not moving" << endl;
			}else
				ans[i].print();
		}
	}


	return 0;
}
