#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int mod = 1000000009;

struct num {
	int x;
	num():x(0) {}
	num(int x):x(x) {}
	num operator+(const num& o) const {
		num res(x+o.x);
		if (res.x >= mod) res.x -= mod;
		return res;
	}
	num operator-(const num& o) const {
		num res(x-o.x);
		if (res.x < 0) res.x += mod;
		return res;
	}
	num operator*(const num& o) const {
		return num(x*(ll)o.x%mod);
	}
};

num to[2][2][30][30][30][2][2];

inline void add(num& a, const num& o) {
	a = a + o;
}

char sh = (char)('a'-1);
void proc(string& s, int n) {
	forn(i, sz(s)) if (s[i] == '?') s[i] = '{';
	while (sz(s) < n) s += sh;
}

num ans[2][2][2];

void solve() {
	string s1, s2, s3;
	cin >> s1 >> s2 >> s3;
	int n = max(max(sz(s1), sz(s2)), sz(s3));
	proc(s1,n);
	proc(s2,n);
	proc(s3,n);
	memset(ans,0,sizeof(ans));
	int cr = 0;
	int nx = 1;
	ans[cr][0][0] = num(1);
	forn(i, n) {
		memset(ans[nx],0,sizeof(ans[nx]));
		char c1 = s1[i]-'a'+1;
		char c2 = s2[i]-'a'+1;
		char c3 = s3[i]-'a'+1;
		forn(i1, 2) forn(i2, 2) forn(j1, 2) forn(j2, 2) add(ans[nx][j1][j2], ans[cr][i1][i2] * to[i1][i2][c1][c2][c3][j1][j2]);
		swap(cr, nx);
	}
	num res = ans[cr][1][1];
	printf("%d\n", res.x);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	
	forn(i1, 2) forn(i2, 2) forn(c1, 27) forn(c2, 27) forn(c3, 27) {
		int f1 = i1;
		int f2 = i2;
		if (c1 != c2) {
			if (!f1 && c1 > c2) continue;
			if (c1 < c2) f1 = 1;
		}
		if (c2 != c3) {
			if (!f2 && c2 > c3) continue;
			if (c2 < c3) f2 = 1;
		}
		//to[i1][i2][c1][c2][c3][f1][f2] = num(1);
		forn(r1, 2) forn(r2, 2) forn(r3, 2) {
			if (r1 && !c1) continue;
			if (r2 && !c2) continue;
			if (r3 && !c3) continue;
			int p1 = c1;
			int p2 = c2;
			int p3 = c3;
			if (r1) p1 = 27;
			if (r2) p2 = 27;
			if (r3) p3 = 27;
			add(to[i1][i2][p1][p2][p3][f1][f2], num(1));
		}
	}
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
