#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1e9;

const double PI = 3.1415926535897932384626433832795;

vector<pii> vig;
bool cmp(pii a,pii b){
	if(a.X == b.X)
		return a.Y<b.Y;
	return a.X>b.X;
}


bool used[200000];
int brute(vector<pii> vv,int k){
	sort(ALL(vv));
	int best = 0;
	do{
		vector<pii> temp;
		for(int i = 0;i <= k;i++){
			temp.pb(vv[i]);
		}
		int will = INF;
		for(int i = 0;i <= k;i++){
			int pr = temp[i].Y;
			int our = temp[i].X;
			will = min(our,will);
			for(int j = i+1;j <= k;j++){
				temp[j].X-=pr;
			}
		}
		best = max(best,will);
	}while(next_permutation(ALL(vv)));

	return best;
}

int mysolyt(vector<pii> vig,int k){
	for(int i = 0;i < L(vig);i++){
		int a = vig[i].X;
		int b = vig[i].Y;
		vig[i].X = a-b;
		vig[i].Y = b;
	}
	vector<pii> check;
	sort(ALL(vig),cmp);
	for(int i = 0;i < min(L(vig),k+1);i++){
		check.pb(vig[i]);
		int a = vig[i].X-vig[i].Y;
		int b = vig[i].Y;
//		check[i] = mp(a,b);
	}
	int ans = brute(check,min(L(vig)-1,k));
	return ans;
}


int smart(vector<pii> vv,int k){
	int n = L(vv);
	int otn = 0;
	for(int i = 0;i < n;i++)
		used[i] = false;
	int ind = 0;
	int vig = 0;
	for(int i = 0;i < n;i++){
		if(vv[i].X-vv[i].Y > vig){
			vig = vv[i].X-vv[i].Y;
			ind = i;
		}
	}
	used[ind] = true;
	int ans = 0;
	while(k>0){
		int cur = 0;
		int id = 0;
		for(int i = 0;i < n;i++){
			if(!used[i]){
				int r1 = vv[i].X-vv[i].Y;
				int r2 = vig-vv[i].Y;
				int mnn = min(r1,r2);
				if(mnn>=cur){
					cur = mnn;
					id = i;
				}
			}
		}
		otn+=vv[id].Y;
		used[id] = true;
		vig = min(vig,cur);
		k--;
	}
	return vig;
}
void comp(vector<pii> ins,int k){
	int a1 = smart(ins,k);
	vector<pii> temp;
	for(int i = 0; i < L(ins);i++){
		int a = ins[i].X;
		int b = ins[i].Y;
		temp.pb(mp(a-b,b));
	}
	int a2 = brute(temp,min(L(temp)-1,k));
	if(a1!=a2){
		cout << "BAD!!!";
		for(int i = 0;i < L(ins);i++){
			cout << ins[i].X << " " << ins[i].Y << " ";
		}
		cout << endl;
		cout << k << endl;
		printf("My = %d Brute = %d\n",a1,a2);
		exit(0);
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int t = 5000;
	//while(t--){
	//	int n = rand()%8;
	//	int k = rand()%8;
	//	cout << t << endl;
	//	vector<pii> inp;
	//	for(int i = 0;i < n;i++){
	//		int a = rand()%30;
	//		int b = rand()%30;
	//		inp.pb(mp(a,b));
	//	}
	//	comp(inp,k);
	//}

	cin >> t;
	while(t--){
		int n,k;
		scanf("%d%d",&n,&k);
		vig.clear();
		for(int i = 0;i < n;i++){
			int a,b;
			scanf("%d%d",&a,&b);
			vig.pb(mp(a,b));
		}

		int ans = smart(vig,k);
//		comp(vig,k);
		//while(k>=0){
		//	sort(ALL(vig),cmp);
		//	int cur = vig[k].X;
		//	ans = min(ans,cur);
		//	int ont = vig[k].Y;
		//	for(int i = 0;i < n;i++){
		//		vig[i].X-=ont;
		//	}
		//	vig[k].X = 0;
		//	vig[k].Y = 0;
		//	k--;
		//}
		//ans = max(ans,0);
		cout << ans << endl;
	}

	return 0;
}
