#include <iostream>
#include <string>

using namespace std;

int get_digit (char c)
{
    return c - '0';
}

const int table2[10][10] = { //left, right -> result
    { 0,  0,  0,  0,  0,  0,  10, 10, 10, 10 }, // 0,
    { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 }, // 1,
    { 20, 22, 22, 23, 23, 25, 26, 28, 28, 29 }, // 2,
    { 29, 29, 33, 33, 33, 36, 36, 36, 39, 39 }, // 3,
    { 40, 40, 40, 44, 44, 45, 46, 47, 48, 49 }, // 4
    { 50, 50, 50, 55, 55, 55, 56, 58, 58, 59 }, // 5
    { 59, 59, 59, 66, 66, 66, 66, 66, 69, 69 }, // 6
    { 70, 70, 70, 70, 77, 77, 77, 77, 78, 79 }, // 7
    { 80, 80, 80, 80, 80, 88, 88, 88, 88, 89 }, // 8
    { 89, 89, 89, 89, 89, 99, 99, 99, 99, 99 } // 9
    };

int get_number2 (const char* chars)
{
    int d1 = get_digit(chars[0]);
    int d2 = get_digit(chars[1]);

    return table2[d1][d2];
}

int get_number (string& s)
{
    if (s.length() == 3)
        return 100*get_digit(s[0]) + get_number2(s.c_str() + 1);
    else if (s.length() == 2)
        return get_number2(s.c_str());
    else
        return get_digit(s[0]);
}

int main()
{
    int tests;
    cin >> tests;
    while (tests--)
    {
        string inp;
        cin >> inp;
        cout << get_number(inp) << endl;
    }
    return 0;
}
