import java.util.Scanner;


public class Main {
	
	public static int sum(int N) {
		long lN = (long)N;
		long result = (lN*(lN+1))/2L;
		return (int)result;
	}
	
	public static int check(int N, int count) {
		int M = (N-sum(count-1));
		//System.out.println(N + " " + count);
		if (M % count == 0) {
			return M/count;
		}
		return -1;
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			int N = in.nextInt();
			if (N==1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			int count = 2;
			int cmax = ((int)Math.sqrt(N)) * 2;
			while (check(N, count) == -1 && count < cmax) {
				++count;
			}
			if (check(N, count) == -1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			StringBuilder buf = new StringBuilder();
			buf.append(N).append(" = ");
			int start = check(N, count);
			buf.append(start);
			for (int i=1;i<count;++i) {
				buf.append(" + ").append(start+i);
			}
			System.out.println(buf);
		}
	}

}
