#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int mod = 1000000009;

string s[3];

void solve() {
	int mxLen = 0;
	for (int i = 0; i < 3; ++i) {
		cin >> s[i];
		mxLen = max(mxLen, (int)s[i].length());
	}

	for (int i = 0; i < 3; ++i) {
		while(s[i].length() < mxLen)
			s[i] += '\0';
	}

	vector<vector<vector<li>>> dp(mxLen + 1, vector<vector<li>>(2, vector<li>(2,0)));
	dp[0][1][1] = 1;

	for (int len = 0; len < mxLen; ++len) {
		char lPossible = 'a', rPossible = 'z';
		if (s[1][len] != '?')
			lPossible = rPossible = s[1][len];

		for (char c = lPossible; c <= rPossible; ++c) {
			
			int goodLess[2] = {0, 0}, goodEq[2] = {0, 0}, goodAll[2] = {0, 0};

			if (s[0][len] != '?') {
				goodAll[0] = 1;
				if (s[0][len] < c)
					goodLess[0] = 1;
				if (s[0][len] == c)
					goodEq[0] = 1;
			}
			else {
				goodAll[0] = 26;
				goodLess[0] = max(0, (signed)c - 'a');
				goodEq[0] = 1;
			}

			if (s[2][len] != '?') {
				goodAll[1] = 1;
				if (s[2][len] > c)
					goodLess[1] = 1;
				if (s[2][len] == c)
					goodEq[1] = 1;
			}
			else {
				goodAll[1] = 26;
				goodLess[1] = min(max(0, 'z' - c), 26);
				goodEq[1] = 1;
			}


			dp[len + 1][0][0] += dp[len][0][0] * goodAll[0] * goodAll[1] + dp[len][0][1] * goodAll[0] * goodLess[1] + dp[len][1][0] * goodAll[1] * goodLess[0] + 
				dp[len][1][1] * goodLess[0] * goodLess[1];
			
			dp[len + 1][1][1] += dp[len][1][1] * goodEq[0] * goodEq[1];

			dp[len + 1][1][0] += dp[len][1][0] * goodEq[0] * goodAll[1] + dp[len][1][1] * goodEq[0] * goodLess[1];

			dp[len + 1][0][1] += dp[len][0][1] * goodEq[1] * goodAll[0] + dp[len][1][1] * goodEq[1] * goodLess[0];

		}

		for (int i = 0; i < 2; ++i)
			for (int j = 0; j < 2; ++j)
				dp[len + 1][i][j] %= mod;

	}

	cout << dp[mxLen][0][0] << "\n";

}