#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

void print(int n, int start, int len) {
    printf("%d = ", n);

    for (int i = 0; i < len - 1; i++) {
        printf("%d + ", start + i);
    }

    printf("%d\n", start + len - 1);
}

int main() {
    int tests;

    scanf("%d", &tests);

    for (int test = 0; test < tests; test++) {
        int n;

        scanf("%d", &n);

        bool f = false;
        for (int k = 2; (long long)k * (k + 1) / 2 <= n; k++) {
            int x = n - k * (k + 1) / 2;

            if (x % k == 0) {
                f = true;
                print(n, 1 + x / k, k);
                break;
            }
        }

        if (!f) {
            printf("IMPOSSIBLE\n");
        }
    }

    return 0;
}
