#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

const int MAX_N = 100005;

int n, a[MAX_N];
char c[MAX_N];

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    int tests;

    cin >> tests;

    for (int test = 0; test < tests; test++) {
        cin >> n;

        int sum_b = 0, sum_w = 0;

        for (int i = 0; i < n; i++) {
            cin >> a[i] >> c[i];

            if (c[i] == 'B') {
                sum_b += a[i];
            } else {
                sum_w += a[i];
            }
        }

        if (sum_w == 0) {
            cout << sum_b << endl;
            continue;
        } else if (sum_b == 0) {
            cout << sum_w << endl;
            continue;
        }

        int g = __gcd(sum_b, sum_w);

        sum_b /= g, sum_w /= g;

        int ans = 0, cur_b = 0, cur_w = 0;

        for (int i = 0; i < n; i++) {
            if (c[i] == 'B') {
                if (cur_w % sum_w != 0) {
                    cur_b += a[i];
                    continue;
                }

                int k = cur_w / sum_w, l = k * sum_b - cur_b;

                if (l > 0 && l <= a[i]) {
                    a[i] -= l;
                    ans++;
                    cur_w = cur_b = 0;
                    i--;
                    continue;
                }

                cur_b += a[i];
            } else {
                if (cur_b % sum_b != 0) {
                    cur_w += a[i];
                    continue;
                }

                int k = cur_b / sum_b, l = k * sum_w - cur_w;

                if (l > 0 && l <= a[i]) {
                    a[i] -= l;
                    ans++;
                    cur_b = cur_w = 0;
                    i--;
                    continue;
                }

                cur_w += a[i];
            }
        }

        cout << ans << endl;
    }

    return 0;
}
