#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int maxn = 1005;

unsigned char dp[14][(1 << 12) + 5][(1 << 12) + 5];

int a[maxn];
int s[maxn];
int test;
bool FLAG;
int min_bit[(1 << 13) + 5];

int top, mask1, mask2, t1, t2, t3, cur_top, cur_mask1, cur_mask2, ans_side, calc_side;

inline void upd(int new_top, int new_mask1, int new_mask2)
{
	if (FLAG)
	{
		if (new_top == cur_top && new_mask1 == cur_mask1 && new_mask2 == cur_mask2)
		{
			t1 = top;
			t2 = mask1;
			t3 = mask2;
			ans_side = calc_side;
		}
	}
	else
	{
		dp[new_top][new_mask1][new_mask2] = test;
	}
}

inline void calc(int j)
{
	for (top = 1; top <= 13; top++) if ((1 << top) <= s[j - 1])
		for (mask1 = 0; mask1 < (1 << top); mask1++)
		{
			mask2 = s[j - 1] - (1 << top) - mask1;
			if (mask2 < 0 || mask2 >= (1 << top) || (dp[top][mask1][mask2] != test))
				continue;
			//add left
			
			calc_side = 0;
			if (mask1 == 0)
			{
				if (a[j] > top)
				{
					//dp[a[j]][0][mask2 | (1 << top)] = test;
					upd(a[j], 0, mask2 | (1 << top));
				}
				else if (a[j] == top)
				{
					upd(top + 1, 0, mask2);
				}
				else upd(top, (1 << a[j]), mask2);
			}
			else if (a[j] <= min_bit[mask1])
			{
				int new_mask1 = mask1 + (1 << a[j]);
				if (new_mask1 == (1 << top))
					upd(top + 1, 0, mask2);
				else if (new_mask1 < (1 << top))
					upd(top, new_mask1, mask2);
			}

			calc_side = 1;
			//add right
			if (mask2 == 0)
			{
				if (a[j] > top)
				{
					upd(a[j], mask1 | (1 << top), 0);
				}
				else if (a[j] == top)
				{
					upd(top + 1, mask1, 0);
				}
				else upd(top, mask1, (1 << a[j]));
			}
			else if (a[j] <= min_bit[mask2])
			{
				int new_mask2 = mask2 + (1 << a[j]);
				if (new_mask2 == (1 << top))
					upd(top + 1, mask1, 0);
				else if (new_mask2 < (1 << top))
					upd(top, mask1, new_mask2);
			}
		}
}

void precalc()
{
	forn(j, (1 << 13) + 1)
	{
		for (int h = 0; h <= 13; h++)
			if (j & (1 << h))
			{
				min_bit[j] = h;
				break;
			}
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	//assert(tests < 255);
	precalc();
	for (int T = 1; T <= tests; T++)
	{
		test = T % 255;
		if (test == 1)
		{
			memset(dp, 0, sizeof(dp));
		}
	
		FLAG = false;
		int n;
		scanf("%d", &n);
		int total = 0;
		forn(j, n)
		{
			int h;
			scanf("%d", &a[j]);
			total += a[j];
			for (h = 0; (1 << h) != a[j]; h++) {}
			a[j] = h;
		}
		int total_pow = -1;
		for (int j = 0; j <= 13; j++)
			if (total == (1 << j))
			{
				total_pow = j;
				break;
			}
		if (total_pow == -1)
		{
			printf("no\n");
			continue;
		}
		dp[a[0]][0][0] = test;
		s[0] = (1 << a[0]);
		fore(j, 1, n - 1)
		{
			calc(j);
			s[j] = s[j - 1] + (1 << a[j]);
		}
		if (dp[total_pow][0][0] == test)
		{
			FLAG = true;
			cur_top = total_pow;
			cur_mask1 = 0;
			cur_mask2 = 0;
			vi ans;
			for (int j = n - 1; j >= 1; j--)
			{
				calc(j);
				ans.push_back(ans_side);
				cur_top = t1;
				cur_mask1 = t2;
				cur_mask2 = t3;
			}
			ans.push_back(0);
			for (int j = ans.size() - 1; j >= 0; j--)
				printf("%c", (ans[j] == 0 ? 'l' : 'r'));
			printf("\n");
		}
		else printf("no\n");
	}
}