#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

i64 gcd(i64 x, i64 y)
{
	if (x == 0 || y == 0)
		return x + y;
	if (x > y)
		return gcd(x % y, y);
	else return gcd(y % x, x);
}

int n;
char t[100100];
int a[100100];

inline bool eq(li a, li b , li c, li d) {
	return a * d == b * c;
}

void solve() {
	scanf("%d\n", &n);
	li cnt1, cnt2;
	cnt1 = cnt2 = 0;
	for (int i = 0; i < n; i++) {
		scanf("%d %c\n", &a[i], &t[i]);
		if (t[i] == 'B')
			cnt1 += a[i];
		else
			cnt2 += a[i];
	}
	if (cnt1 == 0 || cnt2 == 0) {
		printf("%d\n", cnt1 + cnt2);
		return;
	}

	li n1, n2;
	n1 = n2 = 0;
	int res = 0;
	for (int i = 0; i < n; i++) {
		if (t[i] == 'B') {
			n1 += a[i];
			if (n2 * cnt1 % cnt2 != 0)
				continue;
			li needed = n2 * cnt1 / cnt2;
			if (needed <= n1 && needed != 0) {
				res++;
				n1 -= needed;
				n2 = 0;
			}
		} else {
			n2 += a[i];
			if (n1 * cnt2 % cnt1 != 0)
				continue;
			li needed = n1 * cnt2 / cnt1;
			if (needed <= n2 && needed != 0) {
				res++;
				n2 -= needed;
				n1 = 0;
			}
		}
	}
	printf("%d\n", res);
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		solve();
}