#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

int n;
char t[100100];
int a[100100];

void solve() {
	scanf("%d\n", &n);
	li cnt1, cnt2;
	cnt1 = cnt2 = 0;
	for (int i = 0; i < n; i++) {
		scanf("%d %c\n", &a[i], &t[i]);
		if (t[i] == 'B')
			cnt1 += a[i];
		else
			cnt2 += a[i];
	}
	if (cnt1 == 0 || cnt2 == 0) {
		printf("%lld\n", cnt1 + cnt2);
		cerr << cnt1 + cnt2 << '\n';
		return;
	}

	li n1, n2;
	n1 = n2 = 0;
	int res = 0;
	for (int i = 0; i < n; i++) {
		if (t[i] == 'B') {
			n1 += a[i];
			if (n2 * cnt1 % cnt2 == 0) {
				li needed = n2 * cnt1 / cnt2;
				if (needed <= n1 && n1 - needed <= a[i] && needed != 0) {
					res++;
					n1 -= needed;
					n2 = 0;
				}
			}
		} else {
			n2 += a[i];
			if (n1 * cnt2 % cnt1 == 0) {	
				li needed = n1 * cnt2 / cnt1;
				if (needed <= n2 && n2 - needed <= a[i] && needed != 0) {
					res++;
					n2 -= needed;
					n1 = 0;
				}
			}
		}
	}
	printf("%d\n", res);
	cerr << res << '\n';
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		solve();
}