#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 1e3;
const int S = 1 << 13;

struct Input {
	int n;
	
	int a[N];	
	bool read () {
		if (scanf("%d", &n) != 1) {
			return 0;
		}
		forn (i, n) {
			scanf("%d", &a[i]);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	string ans;
	
	void write () {
		if (ans.empty()) {
			printf("no\n");
		}
		else {
			printf("%s\n", ans.c_str());
		}
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	char dp[N + 1][S + 1];
	int from[N + 1][S + 1];
	
	int sm[N + 1];
	
	bool ok (int x, int sm) {
		return sm == 0 || x <= (1 << (__builtin_ffs(sm) - 1));
	}
	
	void solve () {
		sm[0] = 0;
		for (int i = 1; i <= n; ++i) {
			sm[i] = sm[i - 1] + a[i - 1];
		}
		
		ans = "";
		if (sm[n] & (sm[n] - 1)) {
			return;
		}
		forn (i, n + 1) {
			memset(dp[i], 0, sm[n] + 1);
			memset(from[i], -1, sizeof(int) * (sm[n] + 1));
		}
		dp[n][0] = 1;
		
		for (int i = n - 1; i > 0; --i) {
			for (int rs = 0; 2 * rs < sm[i]; ++rs) {
				int ls = sm[i] - rs;
				char & res = dp[i][rs];
				int & fr = from[i][rs];
				res = 0;
				if (rs == 0) {
					if (ok(a[i], ls) && dp[i + 1][rs]) {
						res = 1;
						fr = rs * 2;
					}
					if (a[i] >= ls && dp[i + 1][rs]) {
						res = 1;
						fr = rs * 2 + 1;
					}
					if (a[i] < ls && dp[i + 1][a[i]]) {
						res = 1;
						fr = a[i] * 2 + 1;
					}
				}
				else {
					if (ok(a[i], ls) && dp[i + 1][rs]) {
						res = 1;
						fr = rs * 2;
					}
					if (ok(a[i], rs)) {
						if (2 * (rs + a[i]) >= ls) {
							if (dp[i + 1][0]) {
								res = 1;
								fr = 0 * 2 + 1;
							}
						}
						else {	
							if (dp[i + 1][rs + a[i]]) {
								res = 1;
								fr = 2 * (rs + a[i]) + 1;
							}
						}
					}
				}
				
			}
		}
		
		if (dp[1][0] == 0) {
			return;
		}
		ans = "l";
		int rs = 0;
		for (int i = 1; i < n; ++i) {
			if (from[i][rs] & 1) {
				ans += 'r';
			}
			else {
				ans += 'l';
			}
			rs = from[i][rs] >> 1;
		}
	}
	
	void clear () {
		ans = "";
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("e.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
