#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 1000 + 10;
const int inf = 1000 * 1000 * 1000;
const int ssize = 10;

int tc, n;
vector <int> vertex[size];
bool qs[size][size];
int m;
int ans[size][size];
int prs[ssize][ssize];
int msk[1 << ssize];
int noup[ssize];
int sans[size];
int notused[size];

int rec(int cur, int m, int ban, int mask) {
	if (cur == m) {
		int vl = msk[mask];
		for (int i = 0; i < m; i++)
			if (i != ban && (!((mask >> i) & 1))) {
				vl += noup[i];
			}

		return vl;
	}

	if (cur == ban)
		return rec(cur + 1, m, ban, mask);
	return max(rec(cur + 1, m, ban, mask), rec(cur + 1, m, ban, mask ^ (1 << cur)));
}

vector <int> dfs(int v, int fr) {
	sans[v] = 0;
	vector <vector <int> > h;
	for (int i = 0; i < (int) vertex[v].size(); i++) {
		if (vertex[v][i] != fr) {
			h.pb(dfs(vertex[v][i], v));
		} else {
			vector <int> vec;
			h.pb(vec);
		}
	}

	for (int i = 0; i < (int) h.size(); i++)
		for (int j = i + 1; j < (int) h.size(); j++) {
			prs[i][j] = -inf;
			for (int k = 0; k < (int) h[i].size(); k++)
				for (int p = 0; p < (int) h[j].size(); p++)
					if (qs[h[i][k]][h[j][p]]) {
						prs[i][j] = max(prs[i][j], ans[vertex[v][i]][h[i][k]] + ans[vertex[v][j]][h[j][p]] - 1);
					}
		}

	msk[0] = 0;
	int m = vertex[v].size();
	for (int i = 1; i < (1 << m); i++) {
		msk[i] = -inf;
		for (int j = 0; j < m; j++)
			if ((i >> j) & 1) {
				for (int k = j + 1; k < m; k++)
					if ((i >> k) & 1)
						msk[i] = max(msk[i ^ (1 << j) ^ (1 << k)] + prs[j][k], msk[i]); 
				break;
			}
	}

	for (int i = 0; i < (int) h.size(); i++) {
		noup[i] = 0;
		if (vertex[v][i] != fr)
			noup[i] = max(noup[i], sans[vertex[v][i]]);
		for (int j = 0; j < (int) h[i].size(); j++)
			if (qs[v][h[i][j]])
				noup[i] = max(noup[i], ans[vertex[v][i]][h[i][j]]);
	}

	for (int i = 0; i < m; i++)
		notused[i] = rec(0, m, i, 0);
	sans[v] = rec(0, m, -1, 0);
	ans[v][v] = sans[v] + 1;

	for (int i = 0; i < m; i++) {
		//ans[v][vertex[v][i]] = notused[i] + noup[i] + 1;
		for (int j = 0; j < (int) h[i].size(); j++)
			ans[v][h[i][j]] = notused[i] + ans[vertex[v][i]][h[i][j]];
	}

	vector <int> tojoin;
	tojoin.pb(v);
	for (int i = 0; i < (int) h.size(); i++)
		for (int j = 0; j < (int) h[i].size(); j++)
			tojoin.pb(h[i][j]);

	return tojoin;
}

int main() {
//	assert(freopen("input.txt", "r", stdin));
//	assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%d", &n);
		for (int i = 0; i < n; i++)
			vertex[i].clear();
		int v, u;
		for (int i = 0; i < n - 1; i++) {
			scanf("%d%d", &v, &u);
			v--, u--;

			vertex[v].pb(u);
			vertex[u].pb(v);
		}

		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++) {
				qs[i][j] = false;
				ans[i][j] = 0;
			}
		scanf("%d", &m);
		for (int i = 0; i < m; i++) {
			int v, u;
			scanf("%d%d", &v, &u);

			v--, u--;
			qs[v][u] = true;
			qs[u][v] = true;
		}

		dfs(0, 0);

		printf("%d\n", sans[0]);
	}

	return 0;
}