#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = 333;
const int INF = (int) 1e9;
int t, n, a[N], b[N], d[N], ans[N][N];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d", &n);
		vector<int> all;
		for (int i = 0; i < n; ++i) {
			scanf("%d%d%d", &a[i], &b[i], &d[i]);
			all.pb(a[i]), all.pb(b[i]);
		}
		sort(all.begin(), all.end());
		all.resize(unique(all.begin(), all.end()) - all.begin());
		for (int i = 0; i < n; ++i) {
			a[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
			b[i] = lower_bound(all.begin(), all.end(), b[i]) - all.begin();
		}
		for (int l = sz(all) - 1; l >= 0; --l)
			for (int r = l; r < sz(all); ++r) {
				int mx = -1;
				for (int i = 0; i < n; ++i)
					if ((l <= a[i]) && (b[i] <= r) && ((mx == -1) || (d[i] > d[mx]))) mx = i;
				if (mx == -1) {
					ans[l][r] = 0;
					continue;
				}
				ans[l][r] = INF;
				for (int i = a[mx]; i <= b[mx]; ++i)
					ans[l][r] = min(ans[l][r], ans[l][i - 1] + ans[i + 1][r] + d[mx]);
			}
		printf("%d\n", ans[0][sz(all) - 1]);
	}
	return 0;
}