#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;

pii a[N];
int sum[2];

inline void solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		char ch;
		scanf("%d %c", &a[i].fs, &ch);
		a[i].sc = (ch == 'B');
	}
	sum[0] = sum[1] = 0;
	for (int i = 0; i < n; ++i) {
		sum[a[i].sc] += a[i].fs;	
	}
	int w = sum[0], b = sum[1];
	if (w == 0 || b == 0) {
		printf("%d\n", max(w, b));
		return;
	}
	sum[0] = sum[1] = 0;
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		bool need_add = true;
		if (a[i].sc == 0) {
			if ((1LL * w * sum[1] - 1LL * sum[0] * b) % b == 0) {
				ll k = (1LL * w * sum[1] - 1LL * sum[0] * b) / b;
				if (sum[0] + k > 0 && sum[1] > 0 && k >= 0 && k <= a[i].fs) {
					++ans;
					sum[0] = a[i].fs - k;
					sum[1] = 0;
					need_add = false;
				}
			}
		} else {
			if ((1LL * sum[0] * b - 1LL * sum[1] * w) % w == 0) {
				ll k = (1LL * sum[0] * b - 1LL * sum[1] * w) / w;
				if (sum[0] > 0 && sum[1] + k > 0 && k >= 0 && k <= a[i].fs) {
					++ans;
					sum[0] = 0;
					sum[1] = a[i].fs - k;
					need_add = false;
				}
			}
		}
		if (need_add) {
			sum[a[i].sc] += a[i].fs;
		}
	}
	printf("%d\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "I"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
