#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

LL MOD = 1000 * 1000 * 1000 + 9;

int main() {
  ios_base::sync_with_stdio(false);
  int T;
  cin >> T;

  FOR(__t, 0, T) {
    string a, b, c;
    cin >> a >> b >> c;
    int la = a.length(), lb = b.length(), lc = c.length();

    int max_len = max(la, max(lb, lc));
    a.resize(max_len, '0');
    b.resize(max_len, '0');
    c.resize(max_len, '0');
    //vector <vector <int> > dp(max_len + 1, vector <int>(4, 1));

    LL none = 1, first = 0, second = 0, all = 0;

    for (int i = 0; i != max_len; ++i) {
      LL n = none, f = first, s = second, al = all;

      if (a[i] == '?') {
        if (b[i] == '?') {
          if (c[i] == '?') {
            none = n * 26 % MOD;
            first = (f * 26 * 26 + n * (26 * 25) / 2 % MOD) % MOD;
            second = (s * 26 * 26 + n * (26 * 25) / 2 % MOD) % MOD;
            all = (al * 26 * 26 * 26 % MOD + (f + s) * 26 * (26 * 25) / 2 % MOD + n * 26 * 25 * 24 / 6 % MOD) % MOD;
          } else {
            none = n % MOD;
            first = (f * 26 + n * (c[i] - 'a') % MOD) % MOD;
            second = (s * 26 + n * (c[i] - 'a') % MOD) % MOD;
            all = (al * 26 * 26 % MOD + f * (26 * 25) / 2 % MOD + s * 26 * (c[i] - 'a') % MOD + n * (c[i] - 'a') * (c[i] - 'a' - 1) / 2 % MOD) % MOD;                                 
          }
        } else if (c[i] == '?') {
          none = n % MOD;
          first = (f * 26 + n * ('z' - b[i]) % MOD) % MOD;
          second = (s * 26 + n * (b[i] - 'a') % MOD) % MOD;
          all = (al * 26 * 26 % MOD + f * 26 * (b[i] - 'a') % MOD + s * 26 * ('z' - b[i]) % MOD + n * (b[i] - 'a') * ('z' - b[i]) % MOD) % MOD;                                 
        } else {
          none = (b[i] == c[i] ? n : 0);
          first = (f + (b[i] < c[i] ? n : 0)) % MOD;
          second = (b[i] == c[i] ? s * 26 + n * (b[i] - 'a') : 0) % MOD;
          all = (al * 26 % MOD + f * (b[i] - 'a') % MOD + (b[i] < c[i] ? s * 26 : 0) + (b[i] < c[i] ? n * (b[i] - 'a') : 0)) % MOD;                                 
        }
      } else {
        if (b[i] == '?') {
          if (c[i] == '?') {
            none = n;
            first = (f * 26 + n * ('z' - a[i])) % MOD;
            second = (s * 26 + n * ('z' - a[i])) % MOD;
            all = (al * 26 * 26 % MOD + f * ('z' - a[i]) * 26 + s * 26 * 25 / 2 + n * ('z' - a[i]) * ('z' - a[i] - 1) / 2 % MOD) % MOD;
          } else {
            none = (a[i] == c[i] ? n : 0);
            first = (f + (a[i] < c[i] ? n : 0)) % MOD;
            second = (s + (a[i] < c[i] ? n : 0)) % MOD;
            all = (al * 26 + f * ('z' - a[i]) + s * (c[i] - 'a') + (a[i] < c[i] ? n * (c[i] - a[i] - 1) : 0)) % MOD;                                 
          }
        } else if (c[i] == '?') {
          none = (a[i] == b[i] ? n : 0);
          first = (a[i] == b[i] ? f * 26 + n * ('z' - b[i]) : 0) % MOD;
          second = (s + (a[i] < b[i] ? n : 0)) % MOD;                    
          all = (al * 26 + (a[i] < b[i] ? f * 26 : 0) + s * ('z' - b[i]) % MOD + (a[i] < b[i] ? n * ('z' - b[i]) : 0)) % MOD;                                 
        } else {
          none = (a[i] == b[i] && b[i] == c[i] ? n : 0);
          first = ((a[i] == b[i] ? f : 0) + (a[i] == b[i] && b[i] < c[i] ? n : 0)) % MOD;
          second = ((b[i] == c[i] ? s : 0) + (a[i] < b[i] && b[i] == c[i] ? n : 0)) % MOD;
          all = (al + (a[i] < b[i] ? f : 0) + (b[i] < c[i] ? s : 0) + (a[i] < b[i] && b[i] < c[i] ? n : 0)) % MOD;
        }
      }

   //   cout << none << ' ' << first << ' ' << second << ' ' << all << '\n';
    }
    
    cout << all << '\n';
  }
              

  return 0;
}
