#include <iostream>
#include <string>

using namespace std;

const int MAXN = 1000 * 1000 + 5, MOD = 1000 * 1000 * 1000 + 9, SIGMA = 26;
int dp[MAXN][2][2], len[3];
char c[3][MAXN];

int get2(int pj, int j, char c0, char c1) {
    int res = 1;
    if(pj == 1) {
        if(c0 == '?')
            res *= SIGMA;
        if(c1 == '?')
            res *= SIGMA;
        return res;
    }
    if(j == 0) {
        if(c0 == '?') {
            if(c1 == '?')
                return SIGMA;
            if(c1 == 0)
                return 0;
            return 1;
        }
        if(c1 == '?') {
            if(c0 == 0)
                return 0;
            return 1;
        }
        return (int)(c0 == c1);
    }
    if(c0 == '?') {
        if(c1 == '?')
            return SIGMA * (SIGMA - 1) / 2;
        if(c1 == 0)
            return 0;
        return c1 - 'a';
    }
    if(c1 == '?') {
        int k = (c0? SIGMA - (c0 - 'a') - 1 : SIGMA);
        return k;
    }
    return (int)(c0 < c1);
}

int get(int pj, int pk, int j, int k, char c0, char c1, char c2) {
    int res = 1;
    if(pj == 1) {
        if(c0 == '?')
            res *= SIGMA;
        return res * get2(pk, k, c1, c2);
    }
    if(pk == 1) {
        if(c2 == '?')
            res *= SIGMA;
        return res * get2(pj, j, c0, c1);
    }
    if(j == 0) {
        if((c0 == '?' && c1 != 0) || c0 == c1)
            return get2(pk, k, c1, c2);
        if(c1 == '?' && c0 != 0)
            return get2(pk, k, c0, c2);
        return 0;
    }
    if(k == 0) {
        if((c2 == '?' && c1 != 0) || c1 == c2)
            return get2(pj, j, c0, c1);
        if(c1 == '?' && c2 != 0)
            return get2(pj, j, c0, c2);
        return 0;
    }
    if(c0 == '?') {
        if(c1 == '?') {
            if(c2 == '?')
                return SIGMA * (SIGMA - 1) * (SIGMA - 2) / 6;
            if(!c2)
                return 0;
            int k = c2 - 'a';
            return k * (k - 1) / 2;
        }
        if(!c1)
            return 0;
        res *= c1 - 'a';
        if(c2 == '?')
            res *= (SIGMA - (c1 - 'a') - 1);
        else
            res *= (int)(c2 > c1);
        return res;
    }
    if(c1 == '?') {
        if(c2 == '?') {
            int k = (c0? SIGMA - (c0 - 'a') - 1 : SIGMA);
            return k * (k - 1) / 2;
        }
        if(!c2)
            return 0;
        int l = (c0? c0 - 'a' + 1 : 0), r = c2 - 'a';
        return max(0, r - l);
    }
    if(c2 == '?')
        return (int)(c0 < c1) * (SIGMA - (c2 - 'a') + 1);
    return (int)(c0 < c1 && c1 < c2);
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n = 0;
        for(int i = 0; i < 3; i++) {
            string s;
            cin >> s;
            for(size_t j = 0; j < s.length(); j++)
                c[i][j] = s[j];
            len[i] = s.length();
            n = max(n, len[i]);
        }
        for(int i = 0; i < 3; i++)
            for(int j = len[i]; j < n; j++)
                c[i][j] = 0;
        for(int i = 0; i <= n; i++)
            for(int j = 0; j < 2; j++)
                for(int k = 0; k < 2; k++)
                    dp[i][j][k] = 0;
        dp[0][0][0] = 1;
        for(int i = 1; i <= n; i++)
            for(int j = 0; j < 2; j++)
                for(int k = 0; k < 2; k++)
                    for(int pj = 0; pj <= j; pj++)
                        for(int pk = 0; pk <= k; pk++)
                            dp[i][j][k] = (dp[i][j][k] + (long long)get(pj, pk, j, k, c[0][i - 1], c[1][i - 1], c[2][i - 1]) * dp[i - 1][pj][pk]) % MOD;
        cout << dp[n][1][1] << '\n';
    }
    return 0;
}
