#include <iostream>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int MAXN = 605, INF = 1000 * 1000 * 1000 + 5;
int d[MAXN], l[MAXN], r[MAXN], dp[MAXN][MAXN];
pair<int, pair<char, int> > p[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;
        map<int, int> mp;
        for(int i = 0; i < n; i++) {
            cin >> l[i] >> r[i] >> d[i];
            mp[l[i]];
            mp[r[i]];
        }
        int x = 1;
        for(map<int, int>::iterator it = mp.begin(); it != mp.end(); it++)
            it->second = x++;
        for(int i = 0; i < n; i++) {
            l[i] = mp[l[i]];
            r[i] = mp[r[i]];
            p[2 * i] = make_pair(l[i], make_pair(0, i));
            p[2 * i + 1] = make_pair(r[i], make_pair(1, i));
        }
        sort(p, p + 2 * n);
        for(int i = 0; i <= x; i++)
            for(int j = i + 1; j <= x; j++)
                dp[i][j] = INF;
        for(int i = 0; i < x; i++)
            dp[i][i + 1] = 0;
        for(int len = 2; len <= x; len++)
            for(int i = 0; i + len <= x; i++) {
                int j = i + len;
                set< pair<int, int> > st;
                st.insert(make_pair(0, -1));
                for(int k = i + 1, pos = 0; k < j; k++) {
                    while(pos < 2 * n && (p[pos].first < k || (p[pos].first == k && !p[pos].second.first))) {
                        int id = p[pos].second.second;
                        if(l[id] <= i || r[id] >= j) {
                            pos++;
                            continue;
                        }
                        if(p[pos].second.first)
                            st.erase(make_pair(-d[id], id));
                        else
                            st.insert(make_pair(-d[id], id));
                        pos++;
                    }
                    dp[i][j] = min(dp[i][j], -st.begin()->first + dp[i][k] + dp[k][j]);
                }
            }
        cout << dp[0][x] << '\n';
    }
    return 0;
}
