#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int T, n;
struct Cerc{int x, y, r;};
Cerc v[1010];
int sol[2][1010];
bool misca[1010];
vector <int> G[1010];

int Dist(Cerc A, Cerc B)
{
    return ((A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y));
}

int Euclid(int a, int b)
{
    int r;
    while(b)
    {
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

inline void DFS(int x)
{
    vector <int>::iterator it;
    for(it = G[x].begin(); it != G[x].end(); ++it)
    {
        if(!misca[*it])
        {
            misca[*it] = true;
            sol[0][*it] = -sol[0][x] * v[x].r;
            sol[1][*it] = sol[1][x] * v[*it].r;
            int cmmdc = Euclid(abs(sol[0][*it]), abs(sol[1][*it]));
            sol[0][*it] /= cmmdc;
            sol[1][*it] /= cmmdc;
            DFS(*it);
        }
    }
}

int main ()
{
#ifdef local
    freopen ("d.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j, d;
    cin >> T;
    while(T--)
    {
        cin >> n;
        for(i = 1; i <= n; ++i)
        {
            cin >> v[i].x >> v[i].y >> v[i].r;
            sol[0][i] = sol[1][i] = 0;
            misca[i] = false;
            G[i].clear();
        }
        sol[0][1] = sol[1][1] = 1;
        misca[1] = true;
        for(i = 1; i <= n; ++i)
        {
            for(j = i + 1; j <= n; ++j)
            {
                d = Dist(v[i], v[j]);
                if(d == (v[i].r + v[j].r) * (v[i].r + v[j].r))
                {
                    G[i].push_back(j);
                    G[j].push_back(i);
                }
            }
        }
        DFS(1);
        for(i = 1; i <= n; ++i)
        {
            if(misca[i])
            {
                cout << abs(sol[0][i]);
                if(sol[1][i] > 1)
                    cout << "/" << sol[1][i];
                if(sol[0][i] < 0)
                    cout << " counterclockwise\n";
                else
                    cout << " clockwise\n";
            }
            else
                cout << "not moving\n";
        }
    }
    return 0;
}
