#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int sol[210], f[410];

int ok (int x)
{
    int inv = 0, now, lin, col, cif, newlin, newcol;
    while(x)
    {
        inv = inv * 10 + x % 10;
        x /= 10;
    }
    now = lin = col = 1;
    while(inv)
    {
        cif = inv % 10;
        inv /= 10;
        if(cif == 0)
        {
            now = 0;
            col = 4;
            lin = 4;
            continue;
        }
        newlin = cif / 3;
        if(cif % 3 != 0)
            newlin++;
        newcol = cif % 3;
        if(newcol == 0)
            newcol = 3;
        if(lin > newlin || col > newcol)
            return 0;
        lin = newlin;
        col = newcol;
        now = cif;
    }
    return 1;
}

int main ()
{
#ifdef local
    freopen ("h.in", "r", stdin);
    freopen ("", "w", stdout);
#endif

    int t, n;
    int i, j;

    for (i = 1; i <= 400; i ++)
        f[i] = ok(i);
    for (i = 1; i <= 200; ++i)
    {
        if(f[i])
            sol[i] = i;
        else
        {
            for(j = 1; i - j > 0 || i + j <= 400; ++j)
            {
                if((i - j) > 0 && f[i - j])
                    sol[i] = i - j;
                if((i + j) <= 400 && f[i + j])
                    sol[i] = i + j;
                if(sol[i])
                    break;
            }
        }
    }
    scanf("%d", &t);
    while (t -- )
    {
        scanf ("%d", &n);
        printf("%d\n", sol[n]);
    }
    return 0;
}
