#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

typedef long long int Z;

const Z F = 40000;
bool alq[F];

int main() {
	vector<Z> alqs;
	fill(alq, alq + F, true);
	for(Z i = 2; i < F; ++i) {
		for(Z x = i + i; x < F; x += i) {
			alq[x] = false;
		}
	}
	for(Z i = 2; i < F; ++i) {
		if(alq[i]) alqs.push_back(i);
	}
	
	int Te;
	cin >> Te;
	
	for(int te = 0; te < Te; ++te) {
		Z n;
		cin >> n;
		
		Z fuu = 2 * n;
		
		Z m = 0;
		Z expm = 1;
		while(!(fuu & 1)) {
			++m;
			expm *= 2;
			fuu >>= 1;
		}
		
		if(fuu == 1) {
		 	cout << "IMPOSSIBLE\n";
		} else {
			Z l = fuu / 2;
			
//			cout << 2 * n << " = 2^" << m << " * " << 2 * l + 1 << "\n";
			
			Z k1, d1, k2, d2;
			{
				if(expm >= 2 * l + 1) {
					d1 = 2 * n;
					k1 = 2 * n;
				} else {
					d1 = expm;
					k1 = (2 * l - d1) / 2;
				}
			}
			{
				Z fu = 2 * l + 1;
				for(Z a : alqs) {
					if((2 * l + 1) % a == 0) {
						fu = a;
						break;
					}
				}
				
				if(fu >= 2 * n / fu) {
					d2 = 2 * n;
					k2 = 2 * n;
				} else {
					d2 = fu;
					k2 = (2 * n / d2 - 1 - d2) / 2;
				}
			}
			
			Z k, d;
			if(d1 < d2) {
				k = k1;
				d = d1;
			} else {
				k = k2;
				d = d2;
			}
			
			cout << n << " = ";
			for(Z i = 1; i <= d; ++i) {
				if(i != 1) cout << " + ";
				cout << k + i;
			}
			cout << "\n";
		}
	}
	
	return 0;
}
