#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 500500;

struct Node {
	double x, y, k;
	int nom;
	Node () {}
	Node (double x, double y, double k, int nom) : x(x), y(y), k(k), nom(nom){}
};

int n, tt, ans[N];
pair<int, int> a[N];

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &tt);
	while (tt--) {
		scanf("%d", &n);
		for (int i = 0; i < n; i++) scanf("%d%d", &a[i].first, &a[i].second);
		vector<Node> s;
		for (int i = n - 2; i >= 0; i--) {
			ans[i] = -1;
			double xt = a[i].first;
			double yt = a[i].second;
			double x1 = a[i].first;
			double y1 = a[i].second;
			double k1 = (a[i + 1].second - a[i].second) * 1.0 / (a[i + 1].first - a[i].first);
			while (!s.empty()) {
				double x0 = s.back().x;
				double y0 = s.back().y;
				double k0 = s.back().k;
				double b0 = y0 - k0 * x0;
				double b1 = y1 - k1 * x1;
				double xx = (b1 - b0) / (k0 - k1);
				if (xx < x0 - 1e-8) {
					s.pop_back();
					continue;
				}
				if ((k1 > k0 - 1e-8) && (fabs(xx - x0) < 1e-8)) {
					s.pop_back();
					continue;
				}
				int nn = s.back().nom;
				if (xx < a[nn + 1].first + 1e-8) {
					ans[i] = s.back().nom;
				}
				xt = xx;
				yt = k0 * xx + b0;
				s.back().x = xt;
				s.back().y = yt;
				break;
			}
			s.push_back(Node(x1, y1, k1, i));
		}
		for (int i = 0; i < n - 1; i++) printf("%d ", ans[i] + 1);
		puts("");
	}
}
                                                           