#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

using namespace std;

int valid[] = {
	0,1,2,3,4,5,6,7,8,9, // 10
	10,11,12,13,14,15,16,17,18,19, // 20
	20,22,23,25,26,28,29, // 27
	33,36,39,40,44,45,46,47,48,49, // 37
	50,55,56,58,59,66,69,70,77,78,79, // 48
	80,88,89,99,100, // 53
	110,111,112,113,114,115,116,117,118,119, // 
	120,122,123,125,126,128,129,
	133,136,139,140,144,145,146,147,148,149,
	150,155,156,158,159,
	166,169,170,177,178,179,
	180,188,189,199,200, -1
};

bool isOK[201];

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	memset(isOK, false, sizeof(isOK));

	for (int i = 0; valid[i] != -1; ++i) {
		isOK[valid[i]] = true;
	}

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		int n;
		cin >> n;
		if (n > 200) {
			cout << 200 << endl;
			continue;
		}

		for (int d = 0; d < 200; ++d) {
			if (n - d >= 1 && isOK[n - d]) {
				cout << n - d << endl;
				break;
			}
			if (n + d <= 200 && isOK[n + d]) {
				cout << n + d << endl;
				break;
			}
		}
	}

	return 0;
}