#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

#define MAX_N 100000
#define DEBUG false

using namespace std;

ll n;
ll l[MAX_N+5];

ll gc[2];//global count ratio (gcd'ed)


inline bool gettype(ll pos) {
	return pos % 2 == 1;
}

ll answer() {
	ll seg = 0;
	ll pos = 0;
	if (n == 1)
		return l[0];

	ll segCount = 0;
	while (seg != n) {
		bool type = gettype(seg);//starting type

		ll c[2] = {0, 0};
		c[type] = l[seg] - pos;

		for (ll i = seg+1; i < n; i++) {
			bool newType = gettype(i);
		
			//cout << (ll)gc[newType] << " * " << (ll)c[!newType] << endl;
			/*
			gc[newType] - gc[!newType]
			X?          - c[!newType]
			*/

			ll top = (ll)gc[newType] * (ll)c[!newType];
			ll bottom = gc[!newType];
			//cout << top << " / " << bottom << endl;
			//printf("%d / %d\n", top, bottom);
			if (top % bottom == 0) {
				ll reqB = (ll)(top / bottom);
				ll needsB = reqB - c[newType];
				if (needsB <= l[i]) {
					segCount++;
					if (needsB < l[i]) {
						seg = i;
						pos = needsB;
					}
					else {
						seg = i+1;
						pos = 0;
					}
					break;
				}
			}
			c[newType] += l[i];
		}
	}
	return segCount;
}


ll gcd(ll a, ll b) {
	while (b != 0) {
		ll temp = a % b;
		a = b;
		b = temp;
	}
	return a;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tests;
	scanf("%d", &tests);
	//tests = 1000;
	for (ll test = 0; test < tests; ++test) {
		n = 0;
		int n0;
		scanf("%d", &n0);
		//n0 = MAX_N;
		char prev;
		for (ll i = 0; i < n0; ++i) {
			int count;
			scanf("%d", &count);
			//count = 10000;
			//char c = i % 2 ? 'W' : 'B';
			char c = ' ';
			while (c != 'B' && c != 'W')
				c = getchar();
			if (i == 0 || c != prev) {
				//new
				l[n++] = count;
			}
			else {
				//append
				l[n-1] += count;
			}
			prev = c;
		}
		
		gc[0] = gc[1] = 0;
		for (ll i = 0; i < n; i += 2)
			gc[0] += l[i];
		for (ll i = 1; i < n; i += 2)
			gc[1] += l[i];
		ll ggcd = gcd(gc[0], gc[1]);
		gc[0] /= ggcd;
		gc[1] /= ggcd;
		if (DEBUG)
			printf("ratio: %d %d\n", gc[0], gc[1]);

		if (DEBUG) {
			for (ll i = 0; i < n; ++i)
				printf("%d ", l[i]);
			printf("\n");
		}
		printf("%d\n", answer());
		if (DEBUG)
			printf("--------------\n");
	}


	return 0;
}