#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

#define MAX_N 100000
#define DEBUG false

using namespace std;

int n;
int l[MAX_N];

int gc[2];//global count ratio (gcd'ed)


inline bool gettype(int pos) {
	return pos % 2 == 1;
}

int answer() {
	int seg = 0;
	int pos = 0;
	if (n == 1)
		return l[0];

	int segCount = 0;
	while (seg != n) {
		if (DEBUG)
			printf("answer %d %d\n", seg, pos);
		bool type = gettype(seg);//starting type

		int c[2] = {0, 0};
		c[type] = l[seg] - pos;

		for (int i = seg+1; i < n; i++) {
			bool newType = gettype(i);

			//cout << (ll)gc[newType] << " * " << (ll)c[!newType] << endl;
			/*
			gc[newType] - gc[!newType]
			X?          - c[!newType]
			*/

			ll top = (ll)gc[newType] * (ll)c[!newType];
			ll bottom = gc[!newType];
			//cout << top << " / " << bottom << endl;
			//printf("%d / %d\n", top, bottom);
			if (top % bottom == 0) {
				ll reqB = (ll)(top / bottom);
				ll needsB = reqB - c[newType];
				//if (DEBUG)
					//cout << "reqB: " << reqB << ", is: " << c[newType] << ", needs: " << needsB << endl;
                //if (needsB <= 0)
                    //while (true);
				if (needsB <= l[i]) {
					segCount++;
					if (needsB < l[i]) {
						seg = i;
						pos = needsB;
					}
					else {
						seg = i+1;
						pos = 0;
					}
					break;
				}
			}
			c[newType] += l[i];
		}
	}
	//if (pos != 0);
	//if (DEBUG)
		//printf("finished %d %d\n", seg, pos);
	return segCount;
}


int gcd(int a, int b) {
	while (b != 0) {
		int temp = a % b;
		a = b;
		b = temp;
	}
	return a;
}

int main() {
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tests;
	scanf("%d", &tests);
	//tests = 1000;
	for (int test = 0; test < tests; ++test) {
		n = 0;
		int n0;
		scanf("%d", &n0);
		//n0 = MAX_N;
		char prev;
		for (int i = 0; i < n0; ++i) {
			int count;
			scanf("%d", &count);
			//count = 10000;
			//char c = i % 2 ? 'W' : 'B';
			char c = ' ';
			while (c != 'B' && c != 'W')
				c = getchar();
			if (i == 0 || c != prev)
				l[n++] = count;//new
			else
				l[n-1] += count;//append
			prev = c;
		}

		gc[0] = gc[1] = 0;
		for (int i = 0; i < n; i += 2)
			gc[0] += l[i];
		for (int i = 1; i < n; i += 2)
			gc[1] += l[i];
		int ggcd = gcd(gc[0], gc[1]);
		gc[0] /= ggcd;
		gc[1] /= ggcd;
		if (DEBUG)
			printf("ratio: %d %d\n", gc[0], gc[1]);

		if (DEBUG) {
			for (int i = 0; i < n; ++i)
				printf("%d ", l[i]);
			printf("\n");
		}
		printf("%d\n", answer());
		if (DEBUG)
			printf("--------------\n");
	}


	return 0;
}
