#if 1
#include<cstdio>
#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cstring>
#include<queue>
#include<stack>

#define X first
#define Y second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long li;
typedef long double ld;
typedef pair<int,int> pii;
typedef  vector<int> vi;

const int nsqrt = 1e5;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	vector<li> sums(nsqrt + 1);
	for (li i = 0; i < nsqrt; ++i) sums[i] = (i * (i + 1)) / 2;
	int T; scanf("%d", &T);
	for (int i = 0; i < T; ++i)
	{
		int v; scanf("%d", &v);
		bool find = false;
		for (int j = 2; sums[j] <= v; ++j)
		{
			li newv = v - sums[j];
			if(newv % j == 0)
			{
				li add = newv / j;
				printf("%d = %d", v, add + 1);
				for (int i = add + 2; i <= add + j; ++i) printf(" + %d", i);
				printf("\n");
				find = true;
				break;
			}
		}
		if(!find) printf("IMPOSSIBLE\n");
	}
	return 0;
}
#endif