#include <stdlib.h>
#include <string.h>
#include <algorithm>
// Author: Adam Polak

#include "ver.h"
#include <cstdio>

const int maxn = 100000;

char S[maxn+2];

int main() {
    oi::Scanner in(stdin);
    int TT = in.readInt(1, 1e9);
    in.readEoln();
    int total = 0;
    while (TT--)
    {
        int len = in.readString(S,maxn+1);
        assert(len>=1 && len<=maxn);
        total += len;
        in.readEoln();
        for(int i=0; i<len; i++)
        {
            if (S[i]!='A' && S[i] !='C' && S[i] != 'G' && S[i] != 'T')
                in.error("A character outside [ACGT] encountered!\n");
        }
    }
    in.readEof();
    printf("OK, total = %d.\n",total);
    return 0;
}
