#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
// Author: Adam Polak

#include <iostream>
#include <string>
#include <vector>
using namespace std;

bool solvable(string a, string b, string c) {
  for (int i = 0; i < 3; ++i) if (a[i] == '?') a[i] = 'a';
  for (int i = 0; i < 3; ++i) if (c[i] == '?') c[i] = 'z';
  for (int k = 0; k < 27; ++k) {
    string x = b;
    if (x[0] == '?') x[0] = 'a' + (k % 3);
    if (x[1] == '?') x[1] = 'a' + ((k / 3) % 3);
    if (x[2] == '?') x[2] = 'a' + (k / 9);
    if (a < x && x < c)
      return true;
  }
  return false;
}

int main() {
  ios_base::sync_with_stdio(false);
  vector<string> tests;
  const int kCases = 1 << (2 * 9);
  for (int k = 0; k < kCases; ++k) {
    string s[3];
    for (int i = 0; i < 9; ++i)
      s[i / 3].push_back("abc?"[(k >> (2 * i)) & 3]);
    if (!solvable(s[0], s[1], s[2])) continue;
    for (int i = 0; i < 3; ++i)
      tests.push_back(s[i]);
  }
  cout << tests.size() / 3 << endl;
  for (int i = 0; i < tests.size(); ++i)
    cout << tests[i] << endl;
}
