#include <stdlib.h>
#include <string.h>
#include <algorithm>
// Author: Robert Obryk
// Forgot long longs
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

struct scase {
    vector<pair<int, bool> > poses; 
    int pop[2];

    void dostuff() {
        int n;
        pop[0] = pop[1] = 0;
        scanf("%d", &n);
        while (n--) {
            int k;
            char sc[100];
            scanf("%d %s", &k, sc);
            bool c = false;
            assert(sc[1] == '\0');
            if (sc[0] == 'B')
                c = true;
            else 
                assert(sc[0] == 'W');
            poses.push_back(make_pair(k, c));
            pop[c == true] += k;
        }
        if (pop[0] == 0) {
            printf("%d\n", pop[1]);
            return;
        }
        if (pop[1] == 0) {
            printf("%d\n", pop[0]);
            return;
        }

        int res = 0;
        int popsofar[2];
        popsofar[0] = popsofar[1] = 0;
        for(int i=0;i<poses.size();i++) {
            bool col = poses[i].second;
            int a = popsofar[col == true], b = popsofar[col == false];
            int c = pop[col == true], d = pop[col == false];
            int xd = b*c - a*d;
            if (xd % d == 0) {
                int x = xd/d;
                if (x >= 0 && x < poses[i].first) {
                    res++;
                }
            }
            popsofar[col == true] += poses[i].first;
        }
        printf("%d\n", res);
    }

};

int main()
{
    int T;
    scanf("%d", &T);
    while (T--) {
        scase s;
        s.dostuff();
    }
    return 0;
}
