#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include "ver.h"
#include <cstdio>

int main() {
  oi::Scanner in(stdin);
  int Z = in.readInt(1, 1e9);
  in.readEoln();
  while (Z--) {
    int n = in.readInt(1, 1e5);
    in.readEoln();
    long long seq_length = 0;
    for (int i = 0; i < n; ++i) {
      int k=in.readInt(1, 1e9);
      seq_length += k;
      in.readSpace();
      char x = in.readChar();
      if (x != 'B' && x != 'W')
        in.error("Char not in {B, W}");
      in.readEoln();
    }
    if (seq_length > 1e9)
     in.error("Sequence of bricks too long!");
  }
  in.readEof();
  printf("OK\n");
  return 0;
}
