#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define index qwe

#define NAME "a"

const int root = 0;

int lca[1003][1003];
int index[1003][1003];
vector <pair <int, int> > path[1003];
vector <int> g[1003];

vector <pair <int, int> > pr[11][2001];

vector <int> precalc(int u, int prev = -1)
{
	vector <int> V(0);
	V.pb(u);
	lca[u][u] = u;
	for (int i = 0; i < sz(g[u]); ++i)
		if (g[u][i] == prev)
		{
			g[u].erase(g[u].begin() + i);
			break;
		}
	for (int i = 0; i < sz(g[u]); ++i)
	{
		vector <int> W = precalc(g[u][i], u);
		for (int j = 0; j < sz(W); ++j)
			for (int k = 0; k < sz(V); ++k)
				lca[W[j]][V[k]] = lca[V[k]][W[j]] = u;
		for (int j = 0; j < sz(W); ++j)
		{
			index[u][W[j]] = i;
			V.pb(W[j]);
		}
		W.clear();
	}
	return V;
}

int sum[1003];
int best_one[11];
int best_two[11][11];
int ans[2001];

int D[1003];

void upd_max(int &a, int b)
{
	a = max(a, b);
}

void dfs_add(int u, int delta)
{
	sum[u] += delta;
	for (int i = 0; i < sz(g[u]); ++i)
		dfs_add(g[u][i], delta);
}

void dfs(int u)
{
	for (int i = 0; i < sz(g[u]); ++i)
		dfs(g[u][i]);
	int deg = sz(g[u]);
	for (int i = 0; i < deg; ++i)
		best_one[i] = D[g[u][i]];
	for (int i = 0; i < deg; ++i)
		for (int j = i + 1; j < deg; ++j)
			best_two[i][j] = 0;
	for (auto &p: path[u])
	{
		int v1 = p.fi, v2 = p.se;
		if (v2 == u)
			swap(v1, v2);
		if (v1 == u)
			upd_max(best_one[index[u][v2]], sum[v2] + 1);
		else
		{
			int i1 = index[u][v1];
			int i2 = index[u][v2];
			if (i1 > i2)
				swap(i1, i2);
			upd_max(best_two[i1][i2], sum[v1] + sum[v2] + 1);
		}
	}
	for (int mask = 0; mask < (1 << deg); ++mask)
		ans[mask] = 0;
	for (int mask = 0; mask < (1 << deg); ++mask)
	{
		for (int q = 0; q < sz(pr[deg][mask]); ++q)
		{
			int i1 = pr[deg][mask][q].fi;
			int i2 = pr[deg][mask][q].se;
			upd_max(ans[mask | (1 << i1) | (1 << i2)], ans[mask] + best_two[i1][i2]);
		}
		for (int q = 0; q < deg; ++q)
		{
			if (mask & (1 << q))
				continue;
			upd_max(ans[mask | (1 << q)], ans[mask] + best_one[q]);
		}
	}
	D[u] = ans[(1 << deg) - 1];
	for (int i = 0; i < deg; ++i)
		dfs_add(g[u][i], ans[((1 << deg) - 1) ^ (1 << i)]);
	sum[u] = D[u];
}

void solve()
{
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		g[i].clear(), path[i].clear();
	for (int i = 0; i < n - 1; ++i)
	{
		int u, v;
		scanf("%d%d", &u, &v);
		--u, --v;
		g[u].pb(v);
		g[v].pb(u);
	}
	precalc(root);
	int m;
	scanf("%d", &m);
	for (int i = 0; i < m; ++i)
	{
		int u, v;
		scanf("%d%d", &u, &v);
		--u, --v;
		int w = lca[u][v];
		path[w].pb(mp(u, v));
	}
	for (int i = 0; i < n; ++i)
		sum[i] = 0, D[i] = 0;
	dfs(root);
	cout << D[root] << '\n';
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	for (int sz = 0; sz <= 10; ++sz)
	{
		for (int mask = 0; mask < (1 << sz); ++mask)
		{
			for (int i1 = 0; i1 < sz; ++i1)
			{
				if (mask & (1 << i1))
					continue;
				for (int i2 = i1 + 1; i2 < sz; ++i2)
				{
					if (mask & (1 << i2))
						continue;
					pr[sz][mask].pb(mp(i1, i2));
				}
			}
		}
	}
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
