#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define index qwe

#define NAME "e"

#define M 9100
#define K 15

short tim = 0;
short used[M][M];
char way[M][M];
pair<short, short> from[M][M];
int n, a[M], sum = 0;
int lowbit[M], highbit[M];

void precalc()
{
	lowbit[0] = (1 << K);
	highbit[0] = (1 << K);
	for (int i = 1; i < M; ++i)
	{
		for (int j = 0; j <= K; ++j)
			if ((i >> j) & 1)
			{
				lowbit[i] = (1 << j);
				break;
			}
		for (int j = K; j >= 0; --j)
			if ((i >> j) & 1)
			{
				highbit[i] = (1 << j);
				break;
			}
	}
}

pair<int, int> gol(int x, pair<int, int> mask)
{
	if (lowbit[mask.fi] < x)
		return mp(-1, -1);
	mask.fi += x;
	if (highbit[mask.fi] == highbit[mask.se])
	{
		mask.se += highbit[mask.fi];
		mask.fi -= highbit[mask.fi];
	}
	return mask;
}

inline pair<int, int> rev(pair<int, int> mask)
{
	swap(mask.fi, mask.se);
	return mask;
}

pair<int, int> gor(int x, pair<int, int> mask)
{
	return rev(gol(x, rev(mask)));
}

void print(pair<int, int> st)
{
	string ans(n, 'x');
	for (int k = n - 1; k >= 0; --k)
	{
		ans[k] = way[st.fi][st.se];
		st = from[st.fi][st.se];
	}
	cout << ans << "\n";
}

void solve()
{
	cin >> n;
	sum = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		sum += a[i];
	}
	
	if (sum != highbit[sum])
	{
		cout << "no\n";
		return;
	}
	
	for (int i = 0; i <= sum; ++i)
		for (int j = 0; j <= sum; ++j)
			used[i][j] = tim;
	
	++tim;
	
	queue<pair<int, pair<int, int>>> q;
	q.push(mp(0, mp(0, 0)));
	used[0][0] = tim;
	pair<int, int> best = mp(-1, -1);
	while (!q.empty())
	{
		auto v = q.front().se;
		int num = q.front().fi;
		int x = a[num];
		q.pop();
		if (num >= n)
		{
			if (v.fi == 0 || v.se == 0)
			{
				best = v;
				break;
			}
			continue;
		}
		
		{
			auto tl = gol(x, v);
			//cerr << v.fi << ", " << v.se << " -> " << tl.fi << ", " << tl.se << " (l)\n";
			if (tl.fi != -1 && used[tl.fi][tl.se] != tim)
			{
				used[tl.fi][tl.se] = tim;
				way[tl.fi][tl.se] = 'l';
				from[tl.fi][tl.se] = v;
				q.push(mp(num + 1, tl));
			}
		}
		
		{
			auto tr = gor(x, v);
			//cerr << v.fi << ", " << v.se << " -> " << tr.fi << ", " << tr.se << " (r)\n";
			if (tr.fi != -1 && used[tr.fi][tr.se] != tim)
			{
				used[tr.fi][tr.se] = tim;
				way[tr.fi][tr.se] = 'r';
				from[tr.fi][tr.se] = v;
				q.push(mp(num + 1, tr));
			}
		}
	}
	
	if (best.fi != -1)
		print(best);
	else
	{
		cout << "no\n";
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	precalc();
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}

