#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "i"

const int maxn = 100000;

int n;
ll k[maxn], bal[maxn + 1];
char c[maxn];

ll gcd(ll a, ll b)
{
	while (a && b)
		if (a > b) a %= b;
		else b %= a;
	return a + b;
}

void solve()
{
	cin >> n;
	ll sumw = 0;
	ll sumb = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> k[i] >> c[i];
		if (c[i] == 'W')
			sumw += k[i];
		if (c[i] == 'B')
			sumb += k[i];
	}
	if (sumb == 0 || sumw == 0)
	{
		cout << sumw + sumb << '\n';
		return;
	}
	ll g = gcd(sumb, sumw);
	sumb /= g, sumw /= g;
	bal[0] = 0;
	for (int i = 0; i < n; ++i)
		if (c[i] == 'W')
			bal[i + 1] = bal[i] + k[i] * sumb;
		else
			bal[i + 1] = bal[i] - k[i] * sumw;
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		ll x = bal[i], y = bal[i + 1];
		if (x > y && x >= 0 && y < 0) ++ans;
		if (x < y && x <= 0 && y > 0) ++ans;
	}
	cout << ans << '\n';
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	cin >> t;
	while (t --> 0) 
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
