#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, k;

pair<int, int> a[150500];

void solve() {
	cin >> n >> k;
	k = min(k, n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	sort(a, a + n);

	vector<vector<int>> dp(n + 1, vector<int>(k + 1, 0));
	for (int i = n - 1; i >= 0; --i)  {
		dp[i][0] = max(dp[i + 1][0], a[i].first - a[i].second);
		for (int l = 1; l <= k; ++l) {
			dp[i][l] = max(dp[i + 1][l], min(dp[i + 1][l - 1] - a[i].second, a[i].first - a[i].second));
		}
	}
	
	cout << dp[0][k] << "\n";

}