#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 150000;
const int K = 10;
const int X = 1000000;

struct Input {
	int n, k;
	
	int c[N], v[N];
	
	bool read () {
		if (!(cin >> n >> k)) {
			return 0;
		}
		++k;
		forn (i, n) {
			scanf("%d%d", &v[i], &c[i]);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	static const int inf = 1e9;
	
	int d[N + 1][K];
	
	bool check (int m) {
		forn (i, n + 1) {
			forn (j, k + 1) {
				d[i][j] = j ? inf : 0;
			}
		}
		forn (i, n) {
			forn (j, k) {
				umn(d[i + 1][j + 1], d[i][j + 1]);
				int s = d[i][j] + c[i];
				if (v[i] >= s + m) {
					umn(d[i + 1][j + 1], s);
				}
			}
		}
		return d[n][k] < inf;
	}
	
	void solve () {
		{
			ve<pii> q;
			forn (i, n) {
				q.pb(mp(v[i], c[i]));
			}
			sort(all(q));
			forn (i, n) {
				v[i] = q[i].fs;
				c[i] = q[i].sc;
			}
		}
		int l = 0, r = X;
		while (l < r) {
			int m = (l + r + 1) / 2;
			if (check(m)) {
				l = m;
			} else {
				r = m - 1;
			}
		}
		ans = l;
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("k.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
