import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by olymp on 11/20/14.
 */
public class task_d {
    public static void main(String[] args) {
        new task_d().run();
    }

    long sqr(long x) {
        return x * x;
    }

    final int N = 1111;
    int x[] = new int[N], y[] = new int[N], r[] = new int[N], n;
    boolean good[][] = new boolean[N][N];
    boolean used[] = new boolean[N];
    BigInteger bir[] = new BigInteger[N];
    frac rate[] = new frac[N];

    void dfs(int v) {
        used[v] = true;
        for (int u = 0; u < n; ++u)
            if (good[v][u] && !used[u]) {
                rate[u] = new frac(rate[v].p.multiply(bir[v]).negate(), rate[v].q.multiply(bir[u]));
                dfs(u);
            }
    }

    public void run() {
        Scanner in = new Scanner(System.in);
        PrintWriter out = new PrintWriter(System.out);
        int t = in.nextInt();
        for (int it = 0; it < t; ++it) {
            n = in.nextInt();
            for (int i = 0; i < n; ++i) {
                x[i] = in.nextInt();
                y[i] = in.nextInt();
                r[i] = in.nextInt();
                bir[i] = BigInteger.valueOf(r[i]);
                rate[i] = new frac(BigInteger.ZERO, BigInteger.ONE);
                used[i] = false;
            }
            for (int i = 0; i < n; ++i)
                for (int j = 0; j < n; ++j)
                    good[i][j] = (sqr(x[i] - x[j]) + sqr(y[i] - y[j]) == sqr(r[i] + r[j]));
            rate[0] = new frac(BigInteger.ONE, BigInteger.ONE);
            dfs(0);
            for (int i = 0; i < n; ++i)
                if (rate[i].p.signum() == 0)
                    out.println("not moving");
                else if (rate[i].p.signum() < 0)
                    out.println(rate[i].p.negate() + (rate[i].q.equals(BigInteger.ONE) ? "" : "/" + rate[i].q) + " counterclockwise");
                else
                    out.println(rate[i].p + (rate[i].q.equals(BigInteger.ONE) ? "" : "/" + rate[i].q) + " clockwise");
        }
        out.close();
        in.close();
    }

    public class frac {
        BigInteger p, q;
        frac(BigInteger p, BigInteger q) {
            BigInteger g = p.gcd(q).abs();
            this.p = p.divide(g);
            this.q = q.divide(g);
        }
    }
}
