#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 1000 * 1000 + 10;
const int ssize = 28;
const int mdl = 1000 * 1000 * 1000 + 9;
int tc;

char hsmb[ssize];
int lb[ssize], rb[ssize];
char str[3][size];
int ans[size][4];
int len[4];
int rnum[256];
int help[ssize][ssize][ssize][3][3];

bool checktype(char c1, char c2, int tp) {
	if (tp == 2)
		return true;
	if (tp == 0)
		return c1 == c2;
	return c1 < c2;
}

int gettype(int b1, int b2) {
	if (b1 == 1)
		return 2;
	else
		return b2;
}

int calc(int c1, int c2, int c3, int t1, int t2) {
	int cur = 0;
	for (int i = lb[c1]; i <= rb[c1]; i++)
		for (int j = lb[c2]; j <= rb[c2]; j++)
			for (int k = lb[c3]; k <= rb[c3]; k++)
				cur += checktype(hsmb[i], hsmb[j], t1) * checktype(hsmb[j], hsmb[k], t2);

	return cur;
}

int main() {
	for (int i = -1; i < 26; i++) {
		hsmb[i + 1] = char('a' + i);
		lb[i] = i;
		rb[i] = i;
		rnum[hsmb[i + 1]] = i + 1;
	}
	hsmb[27] = '?';
	lb[27] = 1;
	rb[27] = 26;
	rnum['?'] = 27;

	for (int i = 0; i < ssize; i++)
		for (int j = 0; j < ssize; j++)
			for (int k = 0; k < ssize; k++)
				for (int t1 = 0; t1 < 3; t1++)
					for (int t2 = 0; t2 < 3; t2++)
						help[i][j][k][t1][t2] = calc(i, j, k, t1, t2);

	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		for (int i = 0; i < 3; i++) {
			scanf("%s", str[i]);
			len[i] = strlen(str[i]);
		}

		int tot = max(len[0], max(len[1], len[2]));
		for (int i = 0; i < 3; i++)
			while (len[i] < tot) {
				str[i][len[i]++] = char('a' - 1);
			}

		ans[0][0] = 1;
		for (int i = 0; i < tot; i++) {
			for (int k = 0; k < 4; k++)
				ans[i + 1][k] = 0;
			for (int j = 0; j < 4; j++) {
				for (int k = 0; k < 4; k++)
					if ((j & k) == j) {
						int t1 = gettype(j & 1, k & 1);
						int t2 = gettype(j >> 1, k >> 1);
						ans[i + 1][k] = (ans[i + 1][k] + ans[i][j] * 1ll * help[rnum[str[0][i]]][rnum[str[1][i]]][rnum[str[2][i]]][t1][t2]) % mdl;
					}
			}
		}

		printf("%d\n", ans[tot][3]);
	}

	return 0;
}