#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;

bool black[MAXN];
ll cnt[MAXN];
int n;

void
process()
{
	scanf("%d", &n);
	ll sumW = 0, sumB = 0;
	for (int i = 0; i < n; ++i) {
		int curVal;
		char curC;
		scanf("%d %c", &curVal, &curC);
		black[i] = (curC == 'B');
		cnt[i] = curVal;
		if (black[i]) {
			sumB += cnt[i];
		} else {
			sumW += cnt[i];
		}
	}
	if (sumW == 0 || sumB == 0) {
		printf("%lld\n", max(sumW, sumB));
	} else {
		ll curW = 0, curB = 0;
		int res = 0;
		for (int i = 0; i < n; ++i) {
			if (black[i]) {
				curB += 1;
				cnt[i]--;
				ll x = -1ll;
				if ((sumB * curW - sumW * curB) % sumW == 0) {
					x = (sumB * curW - sumW * curB) / sumW;
				}			
				if (x >= 0ll && x <= cnt[i]) {
					++res;
					curW = 0;
					curB = 0;
					cnt[i] -= x;
				}
				curB += cnt[i];
			} else {
				curW += 1;
				ll x = -1ll;
				cnt[i]--;
				if ((sumW * curB - sumB * curW) % sumB == 0) {
					x = (sumW * curB - sumB * curW) / sumB;
				}
				if (x >= 0ll && x <= cnt[i]) {
					++res;
					curW = 0;
					curB = 0;
					cnt[i] -= x;
				}
				curW += cnt[i];
			}
		}
		printf("%d\n", res);
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}	

	return 0;
}