#include <iostream>

using namespace std;

const int MAXN = 100 * 1000 + 5;
int a[MAXN];
char c[MAXN];

int get(int b, int w, int add, int nb, int nw) {
    int l = 0, r = add;
    while(l < r - 1) {
        int m = (l + r) / 2;
        if((long long)b * nw < (long long)nb * (w + m))
            r = m;
        else
            l = m;
    }
    if((long long)b * nw == (long long)nb * (w + l))
        return l;
    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;
        int b = 0, w = 0;
        for(int i = 0; i < n; i++) {
            cin >> a[i] >> c[i];
            if(c[i] == 'B')
                b += a[i];
            else
                w += a[i];
        }
        if(!b) {
            cout << w << '\n';
            continue;
        }
        if(!w) {
            cout << b << '\n';
            continue;
        }
        int nn = n;
        n = 0;
        for(int i = 1; i < nn; i++)
            if(c[i] == c[n])
                a[n] += a[i];
            else {
                n++;
                a[n] = a[i];
                c[n] = c[i];
            }
        n++;
        a[n] = 0;
        if(c[n - 1] == 'B')
            c[n] = 'W';
        else
            c[n] = 'B';
        n++;
        int ans = 0;
        for(int i = 0, k = 0; i + 1 < n;) {
            int curb = 0, curw = 0;
            if(c[i] == 'B')
                curb = a[i] - k;
            else
                curw = a[i] - k;
            for(int j = i + 1; j < n; j++) {
                int newk = (c[j] == 'B'? get(curw, curb, a[j], w, b) : get(curb, curw, a[j], b, w));
                if(newk == -1) {
                    if(c[j] == 'B')
                        curb += a[j];
                    else
                        curw += a[j];
                }
                else {
                    i = j;
                    k = newk;
                    ans++;
                }
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
