#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;




int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	while (t--) {
		int n;
		scanf("%d", &n);
		set <pair <int, pair <int, int> > > aliens;
		for (int i = 0; i < n; i++) {
			int a, b, d;
			scanf("%d%d%d", &a, &b, &d);
			aliens.insert(mp(b, mp(a, d)));
		}
		int ans = 0;
		while (!aliens.empty()) {
			pair <int, pair <int, int> > alien = *aliens.begin();
			vector <pair <int, pair <int, int> > > killed;
			killed.pb(alien);
			int mx = -1;
			for (set <pair <int, pair <int, int> > >::iterator it = aliens.begin(); it != aliens.end(); it++) {
				if (it->Y.X <= alien.X) {
					mx = max(mx, it->Y.Y);
					killed.pb(*it);
				}
			}
			for (int i = 0; i < sz(killed); i++)
				aliens.erase(killed[i]);
			ans += mx;
		}
		printf("%d\n", ans);
	}

	return 0;
}