#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n;

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	return true;
}

void solve() {
	int k = n * 2;

	for (int b = 2; li(b) * b <= k; ++b) {
		if (k % b != 0)
			continue;

		int a = k / b - (b - 1);

		if ((a & 1) || a < 0)
			continue;

		a >>= 1;

		if (a == 0)
			continue;

		printf("%d = ", n);

		forn(i, b) {
			if (i)
				printf(" + ");
			printf("%d", a + i);
		}

		puts("");
		return;
	}

	puts("IMPOSSIBLE");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}