#include <iostream>
#include <cstdio>

using namespace std;

int n;

bool check(int k) {
 	if (2 * n % k != 0) return 0;
 	int a0 = 2 * n / k - k + 1;
 	if (a0 <= 0 || a0 % 2 != 0) return 0;
 	a0 /= 2;
 	cout << n << " = ";
 	for (int i = 0; i < k; i++) {
 		if (i) cout << " + ";
 		cout << a0 + i;
 	}
 	cout << endl; 
}

int main() {
 	freopen("input.txt", "r", stdin);
 	
 	int T;
 	cin >> T;
 	while (T--) {
 		cin >> n;
 		bool found = 0;
 		for (int k = 2; k * (k + 1) / 2 <= n; k++) {
 		 	if (check(k)) {
 		 		found = 1;
 		 		break;
 		 	}
 		}
 		if (!found) cout << "IMPOSSIBLE\n";
 	}
	return 0;
}