#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

typedef long long ll;

const int maxn = 1 << 17;
const int maxm = 16;

int n;
int a[maxn];
char c[maxn];

int sign(ll x) {
	if (x < 0) return -1;
	if (x == 0) return 0;
	return 1;
}

int main() {
	freopen("input.txt", "r", stdin);

	int T;
	scanf("%d\n", &T);
	while (T--) {
		scanf("%d\n", &n);
		int sumW = 0, sumB = 0;
		for (int i = 0; i < n; i++) {
			scanf("%d %c\n", &a[i], &c[i]);
			if (c[i] == 'B') sumB += a[i];
			if (c[i] == 'W') sumW += a[i];
		}
		
		if (sumB == 0 || sumW == 0) {
			printf("%d\n", sumW + sumB);
			continue;
		}

		int ans = 0;
		int sw2 = 0, sb2 = 0;
		for (int i = 0; i < n; i++) {
			if (c[i] == 'B') {
				long long tx = sw2 * 1LL * sumB - sb2 * 1LL * sumW;
				if ((sw2 != 0) && (tx >= 0) && (tx % sumW == 0) && (tx / sumW <= a[i])) {
					ans++;
					sw2 = sb2 = 0;
					sb2 = a[i] - tx / sumW;
				} else {
					sb2 += a[i];
				}
			} else {
				long long tx = sumW * 1LL * sb2 - sw2 * 1LL * sumB;
				if ((sb2 != 0) && (tx >= 0) && (tx % sumB == 0) && (tx / sumB <= a[i])) {
					ans++;
					sw2 = sb2 = 0;
					sw2 = a[i] - tx / sumB;
				} else {
					sw2 += a[i];
				}
			}
		}
		if ((sb2 > 0) || (sw2 > 0)) ans++;
		printf("%d\n", ans);
	}

	return 0;
}