#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"


//LL get00_00(string s)
//{
//    sort(all(s));
//    int cnt = count(s.begin(), s.end(), '?');
//    if (cnt == 3)
//        return 26;
//    if (cnt == 2)
//        return 1;
//    if (cnt == 1)
//        return s[1] == s[2];
//    if (cnt == 0)
//        return s[0] == s[1] && s[1] == s[2];
//}
//
//
//LL get11_11(string s)
//{
//    int cnt = count(s.begin(), s.end(), '?');
//    LL res = 1;
//    forn(i, cnt)
//        res *= 26;
//    return res;
//}
//
//LL get11_10(string s)
//{
//    LL res = 1;
//    if (s[0] == '?')
//        res = 26;
//
//    if (s[1] == '?' && s[2] == '?')
//        res *= 26 * 25 / 2;
//    else if (s[1] == '?' && s[2] != '?')
//        res *= betw('a', s[2] - 1);
//    else if (s[1] != '?' && s[2] == '?')
//        res *= betw(s[1] + 1, 'z');
//    else
//        res *= s[1] < s[2];
//
//    return res;
//}
//
//LL get11_01(string s)
//{
//    LL res = 1;
//    if (s[2] == '?')
//        res = 26;
//
//    if (s[0] == '?' && s[1] == '?')
//        res *= 26 * 25 / 2;
//    else if(s[0] == '?' && s[1] != '?')
//        res *= s[1] - 'a';
//    else if (s[0] != '?' && s[1] == '?')
//        res *= 26 - (s[0] - 'a') - 1;
//    else
//        res *= s[0] < s[1];
//
//    return res;
//}
//
//LL get11_00(string s)
//{
//    if (s[0] == '?' && s[1] == '?' && s[2] == '?')
//        return 26 * 25 * 24 / 6;
//
//    if (s[0] == '?' && s[1] != '?' && s[2] != '?')
//        return betw('a', s[0] - 1) * int(s[1] < s[2]);
//    if (s[0] != '?' && s[1] == '?' && s[2] != '?')
//        return int(s[0] < s[2]) * betw(s[0] + 1, s[2] - 1);
//    if (s[0] != '?' && s[1] != '?' && s[2] == '?')
//        return int(s[0] < s[1]) * betw(s[1] + 1, 'z');
//
//    if (s[0] == '?' && s[1] == '?' && s[])
//}


//if (dp[i - 1][0][0])
//    upd(dp[i][0][0], dp[i - 1][0][0] * get00_00(abc));

//if (dp[i - 1][1][1]) upd(dp[i][1][1], dp[i - 1][1][1] * get11_11(abc));
//if (dp[i - 1][1][0]) upd(dp[i][1][1], dp[i - 1][1][0] * get11_10(abc));
//if (dp[i - 1][0][1]) upd(dp[i][1][1], dp[i - 1][0][1] * get11_01(abc));
//if (dp[i - 1][0][0]) upd(dp[i][1][1], dp[i - 1][0][0] * get11_00(abc));

const int mod = 1e9 + 9;
const int maxn = 1000005;
int dp[maxn][2][2];


void upd(int &a, int b)
{
    a += b;
    if (a >= mod)
        a -= mod;
}

int betw(char a, char b)
{
    if (a > b) return 0;
    return b - a + 1;
}

string abc(3, '-');

string q(3, ' ');

int I, L0, L1;

void go(int t)
{
    if (t == 3)
    {
        if (L0 == 0 && q[1] < q[0])
            return;
        if (L1 == 0 && q[2] < q[1])
            return;

        upd(dp[I + 1][L0 || q[0] < q[1]][L1 || q[1] < q[2]], dp[I][L0][L1]);
    }
    else
    {
        if (abc[t] == '?')
        {
            char ch = 'z';
            for (char i = 'a'; i <= ch; i++)
            {
                q[t] = i;
                go(t + 1);
            }
        }
        else
        {
            q[t] = abc[t];
            go(t + 1);
        }
    }
}

char buf[maxn];

void solve()
{
    vector <string> s(3);
    int maxLen = 0;
    for (int i = 0; i < 3; i++)
    {
        scanf("%s", buf);
        s[i] = string(buf);
        maxLen = max(maxLen, (int)s[i].size());
    }
    for (int i = 0; i < 3; i++)
        s[i] += string(maxLen - (int)s[i].size(), '#');

    memset(dp, 0, sizeof(dp));
    dp[0][0][0] = 1;

    int n = maxLen;
    for (int i = 0; i < n; i++)
    {
        forn(j, 3)
            abc[j] = s[j][i];

        for (int less0 = 0; less0 < 2; less0++)
            for (int less1 = 0; less1 < 2; less1++)
            {
                if (dp[i][less0][less1])
                {
                    I = i, L0 = less0, L1 = less1;
                    go(0);
                }
            }
    }

    printf("%d\n", dp[n][1][1]);

}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);

    int t; scanf("%d", &t);
    while (t--)
        solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif